/***********************************************************************/
/*                                                                     */
/*  FILE        :SLib.c                                                */
/*  DATE        :Mon, Sep 22, 2003                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3664F                                              */
/*                                                                     */
/*  This file is generated by Hitachi Project Generator (Ver.2.1).     */
/*                                                                     */
/***********************************************************************/
                  
#include "slib.h"
#include "dprintf.h"
#include "PS2KBD.h"
#include "timerA.h"
#include "iodefine.h"
#include "lcd.h"
#ifdef __cplusplus
extern "C" {
#endif
void abort(void);
#ifdef __cplusplus
}
#endif

/*-------------------------------------------------------
SWITCH UNITS
-------------------------------------------------------*/
void SwInterruptEnable()
{
	//For Switch-1
	IO.PMR1.BIT.IRQ2=1;
	IEGR1.BIT.IEG2=1;
	IENR1.BIT.IEN2=1;
	//For Switch-2
	IO.PMR1.BIT.IRQ3=1;
	IEGR1.BIT.IEG3=1;
	IENR1.BIT.IEN3=1;
	//P81,P82 PORT DIRECTION
	IO.PCR8|=0x06;
}

//IRQ荞݂fBZ[uALEDB
void SwInterruptDisable()
{
	IENR1.BIT.IEN2=0;
	IENR1.BIT.IEN3=0;
	IO.PDR8.BIT.B1=1;
	IO.PDR8.BIT.B2=1;
}

//S2ꂽ̊荞ݏBIRQ2̊荞݃xN^łꂪs
void Irq2()
{
	IRR1.BIT.IRRI2=0;
	IO.PDR8.BIT.B1=~IO.PDR8.BIT.B1;
}

//S3ꂽ̊荞ݏBIRQ3̊荞݃xN^łꂪs
void Irq3()
{
	IRR1.BIT.IRRI3=0;
	IO.PDR8.BIT.B2=~IO.PDR8.BIT.B2;
}

/*-------------------------------------------------------
XCb`̃eXg֐
-------------------------------------------------------*/
void SwTest()
{
	int c;
	dprintf("Switch test:\n");
	dprintf("Push S1 or S2(To go to next step, please any key of PC keyboard.):\n");
	SwInterruptEnable();
	do {
		c=rsdgetc();
	}while(c==-1);
	SwInterruptDisable();
}

/*-------------------------------------------------------
FAN CONTROL UNITS
-------------------------------------------------------*/
volatile int FanRPM=0;			//FanCntTvO邱ƂɂA]x𓾂B
extern volatile int FanCnt;		//pXJEgB1bɃNA

/*-------------------------------------------------------
TÅ荞ݖɎs֐
TÅ荞݂ɂA1bԊuŎs֐
-------------------------------------------------------*/
void FanTimer()
{
	FanRPM=FanCnt;
	FanCnt=0;
}

volatile int PWMDat=0;	//PWM"ON"̋Ԃ\ϐ
volatile int pwmcnt=0;	//PWM̃JE^

/*-------------------------------------------------------
TÅ荞ݖɎs֐
t@̓d̃XCb`OiP84ŐjPWMŐ䂷
-------------------------------------------------------*/
void PWMTimer()
{

	//PWM Control
	if(pwmcnt<PWMDat){
		IO.PDR8.BIT.B4=1;
	}else{
		IO.PDR8.BIT.B4=0;
	}
	pwmcnt++;
	if(pwmcnt>=255)
		pwmcnt=0;
	
}

/*-------------------------------------------------------
t@̂߂̏֐
-------------------------------------------------------*/
void FanCtrlInit()
{
	IO.PCR8|=0x10;			//P84o͂ɐݒ
	IO.PMR1.BIT.IRQ0=1;		//P14it@̃pXjIRQ0荞݂Ɏgp
	IEGR1.BIT.IEG0=1;		//IRQ0̗オGbWo
	IENR1.BIT.IEN0=1;		//IRQ0荞݃Cl[ui荞ݖFanCnt++j
	FanCnt=0;
	SetPTimer(FanTimer,1000);	//TAF1000ms̊
	SetTimerA(PWMTimer);		//TAFI[o[t[̊荞
}

//TimerWgAPWM^CvFanControl
void FanCtrlInit2()
{
	IO.PMR1.BIT.IRQ0=1;		//P14it@̃pXjIRQ0荞݂Ɏgp
	IEGR1.BIT.IEG0=1;		//IRQ0̗オGbWo
	IENR1.BIT.IEN0=1;		//IRQ0荞݃Cl[u
	FanCnt=0;
	TW.TMRW.BIT.CTS=1;		//TWJEgX^[g
	TW.TMRW.BIT.PWMD=1;		//P84/FTIODPWMo
	TW.TCRW.BIT.CCLR=1;		//RyA}b`AɂJE^NA
	TW.TCRW.BIT.CKS=3;		//1/8clock
	TW.TCRW.BIT.TOD=0;		//TimerOutputLevel
	TW.GRA=0xff;
	TW.GRD=0;

	SetPTimer(FanTimer,1000);	//1000ms̊
	SetTimerA(0);
}

/*-------------------------------------------------------
^C}Agt@Rg[̃eXg
-------------------------------------------------------*/
void FanTest()
{
	char str[20];
	int ad1;		//RV1̒l
	int rpm;		//]
	int i;

	FanCtrlInit();
	dprintf("Fan Test Start! --- Hit any key to stop test ---\n");

	LcdDisplayMode(true,false,false);		//LCD̃J[\OFF
	//A/D Reg Init
	AD.CSR.BYTE=0;		//芸0NA
	AD.CSR.BIT.SCAN=1;	//XLx[h
	AD.CSR.BIT.CH=2;	//AN0`AN2I

	AD.CSR.BIT.ADST=1;	//ϊX^[g

	while(!AD.CSR.BIT.ADF) ;	//ADϊI҂
	do {
		ad1=(int)(AD.DRA>>8);	//AN0iRV3jADϊʂ̏8bit擾
		rpm=FanRPM*30;
		PWMDat=ad1;
		tsprintf(str,"Val=%d,rpm=%d   ",ad1,rpm);
		LcdXy(0,1);	LcdPuts(str);
		msdelay(10);
	}while(rsdgetc()==-1);		//R\[͂ԌJԂ
	for(i=0;i<19;i++) str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	PWMDat=0;
	IO.PDR8.BIT.B4=0;	//t@̃Xgbv
	dprintf("FanTest End...\n");
	LcdDisplayMode(true,true,false);
}

/*-------------------------------------------------------
^C}Wgt@Rg[̃eXg
-------------------------------------------------------*/
void FanTest2()
{
	char str[20];
	int ad1,rpm;
	int i;

	FanCtrlInit2();
	dprintf("Fan Test2 Start! --- Hit any key to stop test ---\n");

	//Cursol OFF
	LcdDisplayMode(true,false,false);
	//A/D Reg Init
	AD.CSR.BYTE=0;		//芸0NA
	AD.CSR.BIT.SCAN=1;	//XL[h
	AD.CSR.BIT.CH=2;	//AN0`AN2

	//ADϊX^[g
	AD.CSR.BIT.ADST=1;

	while(!AD.CSR.BIT.ADF);	//ADϊI܂őҋ@
	do {
			ad1=(int)(AD.DRA>>8);
			rpm=FanRPM*30;
			TW.GRD=ad1;
			tsprintf(str,"Val=%d,rpm=%d       ",ad1,rpm);
			LcdXy(0,1);	LcdPuts(str);
			msdelay(10);
	}while(rsdgetc()==-1);
	for(i=0;i<19;i++)
		str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	dprintf("FanTest2 End...\n");
	TW.GRD=0;
	IO.PDR8.BIT.B4=0;
	LcdDisplayMode(true,true,false);
}

/*-------------------------------------------------------
TIMER UNITS
-------------------------------------------------------*/
void msdelayTest()
{
	dprintf("msdelay Test\n");
	dprintf("count 5000ms start!\n");
	msdelay(5000);
	dprintf("count end.\n");
}

/*-------------------------------------------------------
vJE^eXg
-------------------------------------------------------*/
void watchTest()
{
	int sec;
	dprintf("Watch Test\n");
	dprintf("Display from 23:59:55 (about 5 seconds)\n");
	SecCnt=55;
	HourCnt=23;
	MinCnt=59;
	FreeTimer=0;
	while(FreeTimer<200){
		sec=SecCnt;
		dprintf("%02d:%02d:%02d\n",HourCnt,MinCnt,SecCnt);
		while(sec==SecCnt);	
	}
	dprintf("Watch Test end\n");

}

/*-------------------------------------------------------
R\[o̓eXg
-------------------------------------------------------*/
void dprintfTest()
{
	int c;
	dprintf("dprintf test:\n");
	dprintf("Hit any key(end='x'):\n");
	do{
		c=rsgetc();
		dprintf("key=%c\n",c);
	}while(c!='x');
}

/*-------------------------------------------------------
PS/2L[{[heXg
-------------------------------------------------------*/
void PS2Test()
{
	int c;
	PS2Init();
	//PS/2 Keyboard test ===================
	dprintf("PS/2 Keyboard test:\n");
	dprintf("Hit any key from PS/2 Keyboard(end='x'):\n");
	do {
		c=PS2dgetc();
		if(c!=-1)
			dprintf("key=%c\n",c);
		c=rsdgetc();
	}while(c!='x');
}

/*-------------------------------------------------------
LCD\@\eXg
-------------------------------------------------------*/
void LcdTest()
{
	dprintf("LCD Test Start.\n -- hit any key --\n");
	rsgetc();
	LcdCls();
	LcdPuts("This is Line 1.");
	rsgetc();
	LcdXy(0,1);
	LcdPuts("This is Line 2.");
	dprintf("-- hit any key --\n");
	rsgetc();
	LcdCls();
	LcdPuts("LCD Ready...");
}

/*-------------------------------------------------------
ADRo[^@\eXg
-------------------------------------------------------*/
void ADTest()
{
	char str[20];
	int ad1,ad2,ad3;
	int i;
	dprintf("A/D Test Start! --- Hit any key to stop test ---\n");

	//Cursol OFF
	LcdDisplayMode(true,false,false);
	//A/D Reg Init
	AD.CSR.BYTE=0;
	AD.CSR.BIT.SCAN=1;
	AD.CSR.BIT.CH=2;

	//Start
	AD.CSR.BIT.ADST=1;

	while(!AD.CSR.BIT.ADF) ;
	do {
			ad1=(int)(AD.DRA>>8);
			ad2=(int)(AD.DRB>>8);
			ad3=(int)(AD.DRC>>8);

			tsprintf(str,"%d:%d:%d    ",ad1,ad2,ad3);
			LcdXy(0,1);	LcdPuts(str);
			msdelay(10);
	}while(rsdgetc()==-1);
	//LCD2sڂ̏
	for(i=0;i<19;i++) str[i]=' ';
	str[19]=0;
	LcdXy(0,1);	LcdPuts(str);
	dprintf("A/D Test End...\n");
	LcdDisplayMode(true,true,false);
}


/*-------------------------------------------------------
C֐
-------------------------------------------------------*/
void main(void)
{
	int c;
	char sec;	
	//Initialize ===========================
	TimerAInit();
	LcdInit(8);

	dprintf("SLib Test Program Ver 1.00\n");
	LcdPuts("LCD Ready...");

	//Test ==============================
	FanTest();
	PS2Test();
	SwTest();
	dprintfTest();
	msdelayTest();
	watchTest();
	LcdTest();
	ADTest();
	FanTest2();
	dprintf("All tests are finished.\nThanks!\n");
	while(1);
}

void abort(void)
{
	
}
