/*==============================================================================
t@CF	timerA.c
@\TvF		TAp^C}
==============================================================================*/

#include "timerA.h"
#include "iodefine.h"
#include "dprintf.h"

#ifndef NULL
#define NULL 0
#endif

/*==============================================================================
NbN\[XƂ32.768kHz̐MOɎꍇ_CLOCK32K_}N
`ĉB
==============================================================================*/
//#define _CLOCK32K_

/*==============================================================================
gɊݒs܂B
}N"USE_AKI-3664"̒`Ŏg肵܂B
gWX^Zp2004N4t^gp̏ꍇɂ
RgAEgĒ`𖳌ĉB
==============================================================================*/
//#define USE_AKI-3664

/*==============================================================================
1sec쐬ׂ̃JEg̃}NSEC_COUNT̒`B
gpgɂďꍇĂ܂B
==============================================================================*/
#ifdef _CLOCK32K_
#define SEC_COUNT 32	/* 31.25*32=1000.0[msec] */
#else
#ifdef USE_AKI-3664
#define SEC_COUNT 244	/* 4.096*244=999.4[msec] */
#else
#define SEC_COUNT 305	/* 3.28*305=1000.4[msec] */
#endif /*end of #ifdef USE_AKI-3664*/
#endif /*end of #ifdef _CLOCK32K_*/

/*==============================================================================
1usec쐬ׂ̏̃}NUSEC_DIVISOR̒`B
gpgɂďꍇĂ܂B
==============================================================================*/
#ifdef _CLOCK32K_
#define USEC_DIVISOR	122	/* 4/32.768k=122[usec] */
#else
#ifdef USE_AKI-3664
#define USEC_DIVISOR	16	/* 256/16M=16[usec] */
#else
#define USEC_DIVISOR	13	/* 256/20M=12.8[usec] */
#endif /*end of #ifdef USE_AKI-3664*/
#endif /*end of #ifdef _CLOCK32K_*/

/*==============================================================================
1msec쐬ׂ̃JEgl̃}NMSEC_COUNT̒`B
gpgɂďꍇĂ܂B
==============================================================================*/
#ifdef _CLOCK32K_
#define MSEC_COUNT	976		/* 122*8=976[usec] */
#else
#ifdef USE_AKI-3664
#define MSEC_COUNT	992		/* 62*16=992[usec] */
#else
#define MSEC_COUNT	1014	/* 1014/13=78 78*12.8=998.4[usec] */
#endif /*end of #ifdef USE_AKI-3664*/
#endif /*end of #ifdef _CLOCK32K_*/

volatile int FreeTimer;			//31.25msi32.768kHzgpjF32.7msi20MHzNbNjF40.96msi16MHzNbNj̃JE^
volatile char SecCnt;			//bJE^
volatile char MinCnt;			//JE^
volatile char HourCnt;			//ԃJE^i24ԕ\j

void (*TimerA)()=NULL;			//^C}AI[o[t[Ɏs֐̃|C^
void (*PTimer)()=NULL;			//I[o[t[荞ݎɎs֐̃|C^isԊuw@\tj
int PTimerCnt=0;
int PTimerValue=0;

/*==============================================================================
֐F	TimerAInit
@\F		TAB
==============================================================================*/
void TimerAInit()
{
#ifdef _CLOCK32K_
	TA.TMA.BYTE=0x1b;	//32.768kHz4(I[o[t[31.25msec)
#else
	TA.TMA.BYTE=0x14;	//NbN256(I[o[t[:20MHz->3.28msec,16MHz->4.096msec)
#endif
	IENR1.BIT.IENTA=1;	//TimerInterrupt Enable
	
}

/*==============================================================================
֐F	TimerAInt
@\F		TA荞ݎɎs֐BTÅ荞݃xN^ɔzuB
==============================================================================*/
void TimerAInt()
{
	static int mscnt=0;
	IRR1.BIT.IRRTA=0;
	mscnt++;
#ifndef _CLOCK32K_ /*Mgp̏*/
	if((mscnt%10)==0) FreeTimer++;
#else				/*32.768kHzgp̏*/
	FreeTimer++;
#endif

	//bAA̎擾
	if(!(mscnt%=SEC_COUNT)){
		SecCnt++;
		if(SecCnt==60){
			SecCnt=0;
			MinCnt++;
			if(MinCnt==60){
				MinCnt=0;
				HourCnt++;
				HourCnt=(HourCnt++)%24;
			}
		}
	}

	//֐̎siZbgĂ鎞̂݁j
	if(TimerA) TimerA();
	if(PTimer){
		PTimerCnt++;
		if(PTimerCnt>=PTimerValue){
			PTimerCnt=0;
			PTimer();
		}
	}
}


/*==============================================================================
֐F	mcsdelay
@\F		mcs[us]ҋ@܂
			20MHz:TCÃCNg12.8us
			16MHz:TCÃCNg16.0us
			32.768kHz:TCÃCNg122.0us
==============================================================================*/
void mcsdelay(int mcs)
{
	int cnt,wrk;
	
	cnt=mcs/USEC_DIVISOR;
	if(!cnt) cnt++;
	wrk=TA.TCA;
	while(wrk==TA.TCA);
	while(cnt){
		wrk=TA.TCA;
		while(wrk==TA.TCA);
		cnt--;
	}
}

/*==============================================================================
֐F	msdelay
@\F		ms[ms]ҋ@܂
==============================================================================*/
void msdelay(int ms)
{
	while(ms){
		mcsdelay(MSEC_COUNT);
		ms--;
	}
}

/*==============================================================================
֐F	SetPTimer
@\F		cntAptimerݒ肵܂B
			^C}ÃI[o[t[񐔂cntɒB閈Ɋ֐ptimers܂
==============================================================================*/
void SetPTimer(void (*ptimer)(),int cnt)
{
	PTimer=ptimer;
	PTimerValue=cnt/3;	//cnt=ms
	PTimerCnt=0;
}

/*==============================================================================
֐F	SetTimerA
@\F		^C}ÃI[o[t[Ɏs֐atimerݒ肵܂B
==============================================================================*/
void SetTimerA(void (*atimer)())
{
	TimerA=atimer;
}
